#define _CRT_SECURE_NO_WARNINGS
#define  _CRT_NON_CONFORMING_SWPRINTFS
#include <vector>

#include <Windows.h>
#include <tchar.h>

#include "direct3d.h" 

////////////////////////////////////////////////



// eLXg`NX
class DirectXText 
{
private:
	ID3DXFont*			pFont;	// Direct3DtHg
	RECT				Rect;	// `̈
	std::vector<TCHAR>	Buf;	// obt@
public:

	// RXgN^
	DirectXText();
	// fXgN^
	virtual ~DirectXText();

	// DirectXtHg쐬
	bool Create(IDirect3DDevice9* pD3DDevice,int FontHeight = 16);

	// ̕`
	void Draw(DWORD Color,int x,int y,const TCHAR* Str,...);
};


// RXgN^
DirectXText::DirectXText()
{
	pFont = NULL;
}

// fXgN^
DirectXText::~DirectXText()
{
	if(pFont != NULL)
		pFont->Release();
}

// DirectXtHg쐬
bool DirectXText::Create(IDirect3DDevice9* pD3DDevice,int FontHeight)
{
	HFONT	hFont = NULL;	// tHgnh
	LOGFONT	LogFont ={};	// tHg\

	// ftHgtHg擾
	hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	// ftHgtHg擾
	GetObject( hFont, sizeof(LOGFONT), &LogFont);
	// DirectXtHg쐬
	if(FAILED(D3DXCreateFont(pD3DDevice, 
		FontHeight,					// 
		LogFont.lfWidth,			// 
		LogFont.lfWeight,			// tHg̑
		0,							// ~bv}bvx
		LogFont.lfItalic,			// C^bNtO
		LogFont.lfCharSet,			// Zbg
		LogFont.lfOutPrecision,		// ۂ̃tHgƖړĨtHg̓̈v@
		LogFont.lfQuality,			// NHeB
		LogFont.lfPitchAndFamily,	// sb`ƃt@~CfbNX
		LogFont.lfFaceName,			// tHg
		&pFont)))
	{
		return false;
	}
	

	return true;
}


// ̕`
void DirectXText::Draw(DWORD Color,int x,int y,const TCHAR* Str,...)
{
	va_list args;
	va_start( args, Str );					// ψ̍ŏ̗vfi[
	int len = _vsctprintf( Str, args ) + 1;	// JEgAk
	if(Buf.size() < (UINT)len)
		Buf.resize(len);						// TCYIɃm
	_vstprintf( &Buf[0], Str, args );			// 𐮌`

	SetRect( &Rect, 0,0,0,0 );
	// `̈TCY擾
	pFont->DrawText(NULL, &Buf[0], -1, &Rect, DT_LEFT | DT_CALCRECT, Color);
	// {`
	Rect.left += x;
	Rect.right += x;
	Rect.top += y;
	Rect.bottom += y;
	pFont->DrawText(NULL, &Buf[0], -1, &Rect, DT_LEFT, Color);
}


////////////////////////////////////////////////


// EBhEvV[WAEBhEɑ΂郁bZ[Ws
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	
	switch(msg){
		// EBhEjꂽƂ
	case WM_DESTROY:
		PostQuitMessage(0);	// WM_QUITbZ[WbZ[WL[ɑ
		return 0;
	}
	// ftHg̃bZ[Ws
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

// WinMain֐iAvP[V̊Jn֐j
// R\[AvP[VƈႢAR\[JȂ
int _stdcall WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	const TCHAR* WC_BASIC = _T("BASIC_WINDOW");
	// VvEBhENXݒ
	WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS,WndProc, 0,0,hInstance,
		(HICON)LoadImage(NULL,MAKEINTRESOURCE(IDI_APPLICATION),IMAGE_ICON,0,0,LR_DEFAULTSIZE | LR_SHARED),
		(HCURSOR)LoadImage(NULL,MAKEINTRESOURCE(IDC_ARROW),IMAGE_CURSOR,0,0,LR_DEFAULTSIZE | LR_SHARED), 
		(HBRUSH)GetStockObject(WHITE_BRUSH), NULL, WC_BASIC , NULL};

	// VvEBhENX쐬
	if(!RegisterClassEx(&wcex)) 
		return false;

	// EBhEA̓fBXvCɈˑBʂ4:3
	const int WINDOW_WIDTH = 640;
	const int WINDOW_HEIGHT = 480;
	// EBhE̍쐬
	HWND hWnd = CreateWindowEx(0,WC_BASIC,
		_T("Application"), WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
		CW_USEDEFAULT,CW_USEDEFAULT,WINDOW_WIDTH,WINDOW_HEIGHT,NULL,NULL,hInstance,NULL);

///////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////
	//	Direct3D̏
	////////////////////////////////////
	Direct3D direct3d;
	direct3d.Create(hWnd,WINDOW_WIDTH,WINDOW_HEIGHT);

	////////////////////////////////
	// tHg쐬
	////////////////////////////////
	DirectXText text;
	text.Create(direct3d.pDevice3D,32);

///////////////////////////////////////////////////////////////////////////////////////////////
		
	// bZ[W[v
	MSG msg = {}; 
	while(msg.message != WM_QUIT) {
		// AvP[VɑĂ郁bZ[WbZ[WL[擾
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			DispatchMessage(&msg);	// AvP[V̊eEBhEvV[WɃbZ[W]
		}
		// bZ[WĂȂƂ
		else{
			//iDirectX̏j

///////////////////////////////////////////////////////////////////////////////////////////////

			// `Jn
			if(SUCCEEDED(direct3d.pDevice3D->BeginScene()))
			{
				DWORD ClearColor = 0xff808080;	// wiNAF
				// wiNA
				direct3d.pDevice3D->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_STENCIL | D3DCLEAR_ZBUFFER, ClearColor, 1.0f, 0 );
		
				// `
				text.Draw(0xffff0000,0,0,_T("Hello DirectX \n"));

				// `I
				direct3d.pDevice3D->EndScene();
			}
			// `攽f
			direct3d.pDevice3D->Present( NULL, NULL, NULL, NULL );

///////////////////////////////////////////////////////////////////////////////////////////////
		}
	}

	
	return 0;
}